function [ll] = alpha_lik(gam,alpha)
% [ll] = alpha_lik(gam,alpha)
% computes the log-likelihood for only the terms that depend on alpha
% gam - gamma matrix, rows=topics, columns=documents
% alpha - alpha parameter vector

[K,D] = size(gam);

% for d = 1:D
%     ll(d) = gammaln(sum(alpha)) - sum(gammaln(alpha))+...
%         sum((alpha-1).*(digamma(gam(:,d))-digamma(sum(gam(:,d)))));
% end
% ll = sum(ll);

ll= sum(sum(repmat(gammaln(sum(alpha)) - sum(gammaln(alpha)),K,D)+...
        repmat(alpha-1,1,D).*(digamma(gam) - repmat(sum(gam),K,1))));   