function [alph, bet, ppi] = billda_m_step(data, nTopic, nLabel, param_folder)
% [alph,bet] = lda_m_step(data,alph,gam,param_folder)
% This function computes the m-step for the lda algorithm
% data - the data matrix rows = words, columns = documents
% gam = matrix of gamma's each column is gamma for a document
% param_folder - location of the save parameters (phi)
% nLabel = number of labels


nDoc = length(data(1,:));
nVocab = length(data(:,1));

% Initialize bet
bet = zeros(nVocab,nTopic);
ppi = zeros(nLabel,nTopic);

% disp('Recomputing Beta');
% bet (word, topic, label)
% ppie (label, topic)
for iDoc = 1:nDoc
    index = data(:,iDoc)>0;
    document = data(index,iDoc);
    repdoc = repmat(document,[1,nTopic]);
    N = length(document);
    
    load([param_folder,'/var',num2str(iDoc)]);
    gam_full(:,iDoc) = gam;
    bet(index,:) = bet(index,:) + repdoc.*phi;
    
    %ppie = ppsi'*phi;
    ppi = ppi + ppsi'*diag(document)*phi; % check this
end

% Normalize Beta and Pi
bet = col_normalize(bet);
ppi = col_normalize(ppi);
gam = gam_full;

% Optimize alpha
count=0; g = 1;
alph = normalize(sum(gam,2))*1e-4;

while(count<200) 
    g = zeros(nTopic,1);
    h = zeros(nTopic,1);

    g = nDoc*(digammas(sum(alph)) - digamma(alph)) + ...
        sum(digamma(gam) - repmat(digamma(sum(gam)),nTopic,1),2);
    
    S = g'*cov(alph)*g;
    if(S<chi2cdf(0.0001,nTopic))
        return;
    end
    
    z = nDoc*trigamms(sum(alph));
    h = -nDoc.*trigamma(alph);
    c = sum(g./h)/(1/z + sum(1./h));

    H_inv_g = (g-c)./h;
    %H = diag(h)+ones(nTopic,1)*z*ones(1,nTopic);    
    alph = alph - H_inv_g;
    
    count = count+1;
end