function [ll] = computeLL(document, alph, bet, gam, phi)
% [ll] = computeLL(document, alph, bet, gam, phi)
% Computes the log-likelihood of a document under the LDA model
% document - vector of word counts
% alph,bet - alph & beta model parameters
% gam,phi - gamma, phi - variational model parameters

K = length(alph);
indx = find(document>0);
document = document(indx);
doc = repmat(document,1,K);
V = length(document);
N = length(document);


term(1) = gammaln(sum(alph))-sum(gammaln(alph))+ ...
    sum((alph-1).*(digamma(gam) - digammas(sum(gam))));
term(2) = sum(sum(doc.*phi.*(repmat(digamma(gam)',V,1) - digammas(sum(gam)))));
term(3) = sum(sum(phi.*doc.*log(bet(indx,:)+eps)));
term(4) = -gammaln(sum(gam)) + sum(gammaln(gam)) -...
    sum((gam-1).*(digamma(gam) - digammas(sum(gam))));
term(5) = -sum(sum(doc.*phi.*log(phi+eps)));

ll = sum(term);
