function [phi, gam, ll] = lda_e_step(document,alph,bet)
% [phi, gam] = lda_e_step(document,alph,bet)
% This function computes the m-step for the lda algorithm
% document - the count of words for one document rows = word counts
% gam = gamma parameter for this document
% alph, bet - current model parameters

index = find(document>0);
doc = full(document(index));
K = length(alph);
doc_rep = repmat(doc,1,K);
V = length(doc);
N = sum(doc);

% Initialize phi & gamma
phi = zeros(V,K);
phi = normalize(repmat(1/K,V,K) + rand(V,K));  
gam = alph + repmat(full(N),K,1)./K;

% Initialize the stopping criterion
count = 0;

deltaPhi = inf;
deltaGam = inf;

while((deltaPhi>1e-5 | deltaGam>1e-5) & count < V)
    gam_old = gam;
    phi_old = phi;    
    
    gam_rep = repmat(exp(digamma(gam')),length(index),1);
    
    phi = bet(index,:).*gam_rep;
    phi = row_normalize(phi);   
%    for v = 1:V
%        phi(v,:) = bet(index(v),:).*exp(digamma(gam'));
 %       phi(v,:) = phi(v,:)./sum(phi(v,:));
        gam = alph + sum(phi.*doc_rep)';
        %end
    
    deltaPhi = norm(phi-phi_old);
    deltaGam = norm(gam-gam_old);

    count = count+1;
end

[ll] = computeLL(document, alph, bet, gam, phi);