function [alph,bet] = lda_m_step(data, K, param_folder, dalph)
% [alph,bet] = lda_m_step(data,alph,gam,param_folder)
% This function computes the m-step for the lda algorithm
% data - the data matrix rows = words, columns = documents
% gam = matrix of gamma's each column is gamma for a document
% param_folder - location of the save parameters (phi)


D = length(data(1,:));
V = length(data(:,1));

% Initialize bet
bet = zeros(V,K);

% disp('Recomputing Beta');
for d = 1:D
    index = find(data(:,d)>0);
    document = full(data(index,d));
    load([param_folder,'/var',num2str(d)]);
    gam_full(:,d) = gam;
    bet(index,:) = bet(index,:) + phi.*repmat(document,1,K); % update bet
end

% Normalize Beta
bet = col_normalize(bet);

% Recompute alph
count=0; g = 1;
gam = gam_full;
if(dalph==0)
    alph = 1e-3.*ones(K,1);
    alph = repmat(0.1,1,K);
    alph = alph./linspace(1,K*2,K);
    alph = alph';
    return;
else
    alph = 1e-6.*sum(gam,2).*rand(K,1)./D;
    del_alph = inf;
    
    while(del_alph>1e-10 && count<100) 
        alph_old = alph;
        g = zeros(K,1);
        h = zeros(K,1);
        
        g = D*(digammas(sum(alph)) - digamma(alph)) + ...
            sum(digamma(gam) - repmat(digamma(sum(gam)),K,1),2);
        
        %     S = g'*cov(alph)*g;
        %     if(S<chi2cdf(0.0001,K))
        %         return;
        %     end
        
        z = D*trigamms(sum(alph));
        h = -D.*trigamma(alph);
        c = sum(g./h)/(1/z + sum(1./h));
        
        H_inv_g = (g-c)./h;
        alph = alph - H_inv_g;
        
        count = count+1;
        del_alph = norm(alph-alph_old);
    end
end